local MC = {
	Event = {},
	data = {
		enabled = true,
		playerID = "",
		dod = 0,
		mis = 0,
		par = 0,
		cri = 0,
		hit = 0,
		blo = 0,
		totalDmg = 0,
		totalAttacks = 0,
		DPA = 0,
		DPS = 0,
		old_dod = 0,
		old_mis = 0,
		old_par = 0,
		old_cri = 0,
		old_hit = 0,
		old_blo = 0,
		old_totalDmg = 0,
		old_totalAttacks = 0,
		old_DPA = 0,
		old_DPS = 0,
		update = true,
	},
	 
}



function MC:On()
	MC.data.enabled = true
	table.insert(Event.Combat.Damage, 		{MC.Event.Damage, 		"Miscalculation", "Handle Damage"})
	table.insert(Event.Combat.Dodge, 		{MC.Event.Dodge, 		"Miscalculation", "Handle Dodges"})
	table.insert(Event.Combat.Immune, 		{MC.Event.Immune, 		"Miscalculation", "Handle Immunes"})
	table.insert(Event.Combat.Miss, 		{MC.Event.Miss, 		"Miscalculation", "Handle Misses"})
	table.insert(Event.Combat.Parry, 		{MC.Event.Parry, 		"Miscalculation", "Handle Parries"})
	table.insert(Event.Combat.Resist, 		{MC.Event.Resist, 		"Miscalculation", "Handle Resists"})
	--table.insert(Event.Combat.Heal, 		{MC.Event.Heal, 		"Miscalculation", "Handle Heal"})
	--table.insert(Event.Unit.Detail.Combat, 	{MC.Event.Combat, 		"Miscalculation", "Handle Combats"})
	--table.insert(Event.System.Update.Begin, {MC.Event.Update, 		"Miscalculation", "Update UI"})
end

function MC:Off()
	MC.data.enabled = false
	MC:UnregisterEvent(Event.Combat.Damage, 		MC.Event.Damage)
	MC:UnregisterEvent(Event.Combat.Dodge, 			MC.Event.Dodge)
	MC:UnregisterEvent(Event.Combat.Immune, 		MC.Event.Immune)
	MC:UnregisterEvent(Event.Combat.Miss, 			MC.Event.Miss)
	MC:UnregisterEvent(Event.Combat.Parry, 			MC.Event.Parry)
	MC:UnregisterEvent(Event.Combat.Resist, 		MC.Event.Resist)
	--MC:UnregisterEvent(Event.Combat.Heal, 			MC.Event.Heal)
	--MC:UnregisterEvent(Event.Unit.Detail.Combat, 	MC.Event.Combat)
	--MC:UnregisterEvent(Event.System.Update.Begin, 	MC.Event.Update)
end


function MC:Toggle()
	MC.data.enabled = not MC.data.enabled
	if MC.data.enabled then
		MC:On()
	else
		MC:Off()
	end
end

function MC:UnregisterEvent(event, func)
	for i, value in ipairs(event) do
		if value[1] == func then
			table.remove(event, i)
		end
	end
end

function MC.Event.LoadEnd(identifier)
	if identifier == "Miscalculation" then
		MC.data.playerID = Inspect.Unit.Lookup("player")
		
		MC:On()
		
		print("Miscalculation loaded. /MC")
	end
end


function MC.Event.Damage(info)
if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
MC.data.totalAttacks = MC.data.totalAttacks +1
	if info.crit then
	MC.data.cri = MC.data.cri +1
	MC.SetText()
	
	elseif info.damageBlocked then
	MC.data.blo = MC.data.blo +1
	MC.SetText()
	
	else
	MC.data.hit = MC.data.hit +1
	MC.SetText()
	end
	
	if info.damage then
	MC.data.totalDmg = MC.data.totalDmg + info.damage
	end
	
	
	end
	
end


function MC.Event.Dodge(info)
	if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
	
	MC.data.dod = MC.data.dod +1
	MC.data.totalAttacks = MC.data.totalAttacks +1
	MC.SetText()
	
	end
	
end
function MC.Event.Immune(info)
	if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
	if info.crit then
	print ("Crit-Immune")
	else
	print("Immune")
	
	end
	end
end
function MC.Event.Miss(info)
	if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
	MC.data.mis = MC.data.mis +1
	MC.data.totalAttacks = MC.data.totalAttacks +1
	MC.SetText()
	
	end
	
end
function MC.Event.Parry(info)
	if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
	MC.data.par = MC.data.par +1
	MC.data.totalAttacks = MC.data.totalAttacks +1
	MC.SetText()
	
	end
	
end
function MC.Event.Resist(info)
	if info.caster == MC.data.playerID and info.target ~= MC.data.playerID then
	if info.crit then
	print ("Crit-Resist")
	else
	print("Resist")
	
	end
	end
end
function MC.Event.SlashHandler(params)
	if params == "show" then
		MC:On()
	elseif params == "hide" then
		MC:Off()
	else
		MC:Toggle()
	end
end


-- start frames
local main = UI.CreateContext("UI")
local bar = UI.CreateFrame("Frame","Bar",main)
local news = UI.CreateFrame("Text","news",main)
local olds = UI.CreateFrame("Text","olds",main)

bar:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",250,20)
	bar:SetBackgroundColor(0,0,0)
	bar:SetWidth(120)
	bar:SetHeight(105)
	bar:SetAlpha(0.4)
	bar:SetLayer(0)
	bar:SetVisible(true)
	
	-- set text colors
	news:SetFontColor(1,1,1,1)
	olds:SetFontColor(1,1,1,1)
	
	
	--set layers and vis
	news:SetLayer(2)
	news:SetVisible(true)
	
	olds:SetLayer(2)
	olds:SetVisible(true)
	
	-- set POS
	
	news:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",270,20)
	olds:SetPoint("TOPLEFT",UI.Native.PortraitTarget,"TOPLEFT",355,20)
	
--end frames

function MC.SetText()
	--MC.ClearText()

	if MC.data.totalAttacks == 1000 then
		MC.data.old_dod = MC.data.dod
		MC.data.old_mis =MC.data.mis
		MC.data.old_par=MC.data.par
		MC.data.old_cri=MC.data.cri
		MC.data.old_hit = MC.data.hit
		MC.data.old_blo = MC.data.blo
		MC.data.old_totalDmg = MC.data.totalDmg
		MC.data.old_totalAttacks = MC.data.totalAttacks
		MC.data.dod = 0
		MC.data.mis = 0
		MC.data.par = 0
		MC.data.cri = 0
		MC.data.hit = 0
		MC.data.blo = 0
		MC.data.totalDmg = 0
		MC.data.totalAttacks = 0
		
		bar:SetWidth(255)
		
		olds:SetText("Old Crit - "..tostring(MC.data.old_cri).." :: " .. tostring((MC.data.old_cri/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Hit - "..tostring(MC.data.old_hit).." :: " .. tostring((MC.data.old_hit/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Miss - "..tostring(MC.data.old_mis).." :: " .. tostring((MC.data.old_mis/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Dodge - "..tostring(MC.data.old_dod).." :: " .. tostring((MC.data.old_dod/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Parry - "..tostring(MC.data.old_par).." :: " .. tostring((MC.data.old_par/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old Block - "..tostring(MC.data.old_blo).." :: " .. tostring((MC.data.old_blo/MC.data.old_totalAttacks)*100).."%"..
	
	"\n".."Old DMG - "..tostring(MC.data.old_totalDmg)..
	
	"\n".."ATK # - "..tostring(MC.data.old_totalAttacks).." :: " .. tostring((math.floor(MC.data.old_totalDmg/MC.data.old_totalAttacks))).."PA")
		end

	
	news:SetText("Crit - "..tostring(MC.data.cri)..
	
	"\n".."Hit - "..tostring(MC.data.hit)..
	
	"\n".."Miss - "..tostring(MC.data.mis)..
	
	"\n".."Dodge - "..tostring(MC.data.dod)..
	
	"\n".."Parry - "..tostring(MC.data.par)..
	
	"\n".."Block - "..tostring(MC.data.blo)..
	
	"\n".."DMG - "..tostring(MC.data.totalDmg)..
	
	"\n".."ATK # - "..tostring(MC.data.totalAttacks))
	
	
	
	
	
end

-- Should clear text frame
function MC.ClearText()
	
	crit:ClearAll()
	
	hit:ClearAll()
	
	miss:ClearAll()
	
	dodge:ClearAll()
	
	parry:ClearAll()
	
	block:ClearAll()
	
	
end

MC.SetText()
table.insert(Event.Addon.Load.End, 				{MC.Event.LoadEnd, 			"Miscalculation", "Init"})
table.insert(Command.Slash.Register("MC"), 		{MC.Event.SlashHandler, 	"Miscalculation", "Slash"})